include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
	LOOP_COUNT	= 100000

bin2byte_exLib	PROTO: DWORD
ShowCpu	PROTO:DWORD

.code
t0	db "00000000", 0
tm	db "01010101", 0
t1	db "11111111", 0

start:
	invoke ShowCpu, 1
	print chr$(13, 10)

	REPEAT 3
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0	; 0 only
	call BinVal1
	push offset tm	; mixed
	call BinVal1
	push offset t1	; 1 only
	call BinVal1
	counter_end
	print str$(eax), 9, "cycles for BinVal1", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinVal2
	push offset tm
	call BinVal2
	push offset t1
	call BinVal2
	counter_end
	print str$(eax), 9, "cycles for BinVal2", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinVal3
	push offset tm
	call BinVal3
	push offset t1
	call BinVal3
	counter_end
	print str$(eax), 9, "cycles for BinVal3", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinToDw
	push offset tm
	call BinToDw
	push offset t1
	call BinToDw
	counter_end
	print str$(eax), 9, "cycles for BinToDw (drizz)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinToDw2
	push offset tm
	call BinToDw2
	push offset t1
	call BinToDw2
	counter_end
	print str$(eax), 9, "cycles for BinToDw2 (drizz+JJ)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call b2dw1
	push offset tm
	call b2dw1
	push offset t1
	call b2dw1
	counter_end
	print str$(eax), 9, "cycles for b2dw1 (Lingo)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call simd_bin2byte
	push offset tm
	call simd_bin2byte
	push offset t1
	call simd_bin2byte
	counter_end
	print str$(eax), 9, "cycles for simd_bin2byte", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke bin2byte_exLib, offset t0
	test eax, eax
	jns @F
	inc eax
	@@:
	invoke bin2byte_exLib, offset tm
	test eax, eax
	jns @F
	inc eax
	@@:
	invoke bin2byte_exLib, offset t1
	test eax, eax
	jns @F
	inc eax
	@@:
	counter_end
	print str$(eax), 9, "cycles for bin2byte_exLib", 13, 10, 10
	ENDM

; Tests for correctness (only one algo at a time, sorry)
  Algo equ b2dw1
  tmp$ CATSTR <print chr$(13, 10, "Testing >, Algo, < (2 lines must match):", 13, 10, "0, 3, 12, 48, 192, 255, 1431655765=1431655765", 13, 10)>
  tmp$
	push chr$("00000000")
	call Algo
	print str$(eax), ", "

	push chr$("00000011")
	call Algo
	print str$(eax), ", "

	push chr$("00001100")
	call Algo
	print str$(eax), ", "

	push chr$("00110000")
	call Algo
	print str$(eax), ", "

	push chr$("11000000")
	call Algo
	print str$(eax), ", "

	push chr$("11111111")
	call Algo
	print str$(eax), ", "

	push chr$("01010101010101010101010101010101y")
	.data
	v1	dd 01010101010101010101010101010101y
	.code
	call Algo
	print str$(eax), "="
	print str$(v1), 13, 10

	print chr$(13, 10, "Code size:", 13, 10)
	mov eax, BinVal1_END
	sub eax, BinVal1
	print str$(eax), " bytes BinVal1", 13, 10

	mov eax, BinVal2_END
	sub eax, BinVal2
	print str$(eax), " bytes BinVal2", 13, 10

	mov eax, BinVal3_END
	sub eax, BinVal3
	print str$(eax), " bytes BinVal3", 13, 10

	mov eax, simd_bin2byte_END
	sub eax, simd_bin2byte
	print str$(eax), " bytes SSE2 qWord", 13, 10

	mov eax, BinToDw_END
	sub eax, BinToDw
	print str$(eax), " bytes BinToDw", 13, 10

	mov eax, BinToDw2_END
	sub eax, BinToDw2
	print str$(eax), " bytes BinToDw2", 13, 10

	mov eax, b2dw1_END
	sub eax, b2dw1
	print str$(eax), " bytes b2dw1", 13, 10

	mov eax, bin2byte_exLib_END
	sub eax, bin2byte_exLib
	print str$(eax), " bytes bin2byte_ex (Masm32 library)", 13, 10, 10

	inkey "Hit any key to get outta here"
	exit

; ################### Algos ############################
OPTION PROLOGUE : NONE
OPTION EPILOGUE : NONE

align 16
simd_bin2byte proc 	; psz:DWORD
	mov eax,[esp+4]
	movsd xmm0, QWORD ptr [eax]
	pxor xmm1, xmm1
	psllq xmm0, 7
	punpcklbw xmm0, xmm1
	pshuflw xmm0, xmm0, 00011011y
	pshufhw xmm0, xmm0, 00011011y
	packuswb xmm0, xmm0
	pshufd xmm0, xmm0, 011100001y
	pmovmskb eax, xmm0
	movzx eax, al
	ret 4
simd_bin2byte endp
simd_bin2byte_END:

align 16
BinToDw proc 	; pszbinstr:DWORD
	mov edx, [esp+1*4]
	xor eax, eax
	jmp @F
	.Repeat
		and ecx, 1
		lea eax, [eax*2+ecx]
	@@:	movzx ecx, byte ptr [edx]
		inc edx
		test ecx, ecx
	.Until Zero?
	ret 1*4
BinToDw endp
BinToDw_END:

align 16
BinToDw2 proc 	; pszbinstr:DWORD		; this one stops when char is a nullbyte
	mov edx, [esp+1*4]
	xor eax, eax
	xor ecx, ecx		; minor change avoiding the jmp: same size, same cycle count
	.Repeat
		and ecx, 1
		lea eax, [eax*2+ecx]
		movzx ecx, byte ptr [edx]
		inc edx
		test ecx, ecx
	.Until Zero?
	ret 1*4
BinToDw2 endp
BinToDw2_END:

       align	16
       db	90h
       
b2dw1 proc	; lpszbinstr:dword
	mov edx, [esp+4]
	mov ecx, 30h
	xor eax,eax
	cmp cl, [edx]
	ja @j
	@@:
	adc eax, eax
	cmp cl, [edx+1]
	@j:
	ja @f
	adc eax, eax
	cmp cl, [edx+2]
	ja @f
	adc eax, eax
	cmp cl, [edx+3]
	ja @f
	adc eax, eax
	cmp cl, [edx+4]
	ja @f
	adc eax, eax
	cmp cl, [edx+5]
	ja @f
	adc eax, eax
	cmp cl, [edx+6]
	ja @f
	adc eax, eax
	cmp cl, [edx+7]
	ja @f
	adc eax, eax
	cmp cl, [edx+8]
	ja @f
	adc eax, eax
	cmp cl, [edx+9]
	ja @f
	adc eax, eax
	cmp cl, [edx+10]
	ja @f
	adc eax, eax
	cmp cl, [edx+11]
	ja @f
	adc eax, eax
	cmp cl, [edx+12]
	ja @f
	adc eax, eax
	cmp cl, [edx+13]
	ja @f
	adc eax, eax
	cmp cl, [edx+14]
	ja @f
	adc eax, eax
	cmp cl, [edx+15]
	ja @f
	adc eax, eax
	cmp cl, [edx+16]
	lea edx, [edx+16]
	jna @b
	@@:
	ret 4
b2dw1 endp
b2dw1_END:

align 16
BinVal0 proc 	; lpSrc
	mov edx, [esp+4]
	push ecx
	lea ecx, [edx+8]
	dec edx
	xor eax, eax
;	int 3
@@:
	inc edx
	cmp ecx, edx
	je @F
;	inc edx
	shl eax, 1
	cmp byte ptr [edx], "0"
	je @B
	cmp byte ptr [edx], "1"
	jne bvpError
	inc eax
	jmp @B
@@:	pop ecx
	ret 4
bvpError:	or eax, -1
	jmp @B
BinVal0 endp
BinVal0_END:

align 16
BinVal1 proc 	; lpSrc:DWORD		; this one stops when char is not 1 or 0
	mov edx, [esp+4]
	dec edx
	or eax, -1
L1:	inc eax
L2:	inc edx
	shl eax, 1
	cmp byte ptr [edx], "0"
	je L2
	cmp byte ptr [edx], "1"
	je L1
	shr eax, 1
	ret 4
BinVal1 endp
BinVal1_END:

xs = 1
align 16
BinVal2 proc 	; lpSrc
;	int 3
	if xs
	mov edx, [esp+4]
	mov edx, [edx]
	else
	push edi
	mov edi, [esp+8]
	mov edx, [edi]
	endif
	push ecx
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	shl eax, 4
	if xs
	mov edx, [esp+8]
	mov edx, [edx+4]
	else
	mov edx, [edi+4]
	endif
	cmp dl, "1"
	jne @F
	add eax, 8	; inc eax
@@:	cmp dh, "1"
	jne @F
	add eax, 4	; 2
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2	; 8
@@:	cmp dh, "1"
	jne @F
	add eax, 1	; 4
@@:	pop ecx
	if xs eq 0
	pop edi
	endif
	ret 4
;bvpError:	or eax, -1
;	jmp @B
BinVal2 endp
BinVal2_END:

xs = 1
align 16
BinVal3 proc 	; lpSrc
;	int 3
	mov edx, [esp+4]
	mov edx, [edx]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	shl eax, 4
	mov edx, [esp+4]
	mov edx, [edx+4]
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	ret 4
;bvpError:	or eax, -1
;	jmp @B
BinVal3 endp
BinVal3_END:

align 16
BinVal4 proc 	; lpSrc
	mov edx, [esp+4]
	mov edx, [edx]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	shl eax, 4
	mov edx, [esp+4]
	mov edx, [edx+4]
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	ret 4
BinVal4 endp
BinVal4_END:

; 
; 
; 

align 16
bin2byte_exLib proc lpword:DWORD

    mov eax, [esp+4]

    cmp BYTE PTR [eax+0], "0"
    jne pass10
    cmp BYTE PTR [eax+1], "0"
    jne pass11
    cmp BYTE PTR [eax+2], "0"
    jne pass12
    cmp BYTE PTR [eax+3], "0"
    jne pass13
    ; -------------------
    mov eax, 0 ; 0000
    jmp nxt
    ; -------------------
  align 4
  pass13:
    ; -------------------
    mov eax, 16 ; 0001
    jmp nxt
    ; -------------------
  align 4
  pass12:
    cmp BYTE PTR [eax+3], "0"
    jne pass14
    ; -------------------
    mov eax, 32 ; 0010
    jmp nxt
    ; -------------------
  align 4
  pass14:
    ; -------------------
    mov eax, 48 ; 0011
    jmp nxt
    ; -------------------
  align 4
  pass11:
    cmp BYTE PTR [eax+2], "0"
    jne pass15
    cmp BYTE PTR [eax+3], "0"
    jne pass16
    ; -------------------
    mov eax, 64 ; 0100
    jmp nxt
    ; -------------------
  align 4
  pass16:
    ; -------------------
    mov eax, 80 ; 0101
    jmp nxt
    ; -------------------
  align 4
  pass15:
    cmp BYTE PTR [eax+3], "0"
    jne pass17
    ; -------------------
    mov eax, 96 ; 0110
    jmp nxt
    ; -------------------
  align 4
  pass17:
    ; -------------------
    mov eax, 112 ; 0111
    jmp nxt
    ; -------------------
  align 4
  pass10:
    cmp BYTE PTR [eax+1], "0"
    jne pass18
    cmp BYTE PTR [eax+2], "0"
    jne pass19
    cmp BYTE PTR [eax+3], "0"
    jne pass110
    ; -------------------
    mov eax, 128 ; 1000
    jmp nxt
    ; -------------------
  align 4
  pass110:
    ; -------------------
    mov eax, 144 ; 1001
    jmp nxt
    ; -------------------
  align 4
  pass19:
    cmp BYTE PTR [eax+3], "0"
    jne pass111
    ; -------------------
    mov eax, 160 ; 1010
    jmp nxt
    ; -------------------
  align 4
  pass111:
    ; -------------------
    mov eax, 176 ; 1011
    jmp nxt
    ; -------------------
  align 4
  pass18:
    cmp BYTE PTR [eax+2], "0"
    jne pass112
    cmp BYTE PTR [eax+3], "0"
    jne pass113
    ; -------------------
    mov eax, 192 ; 1100
    jmp nxt
    ; -------------------
  align 4
  pass113:
    ; -------------------
    mov eax, 208 ; 1101
    jmp nxt
    ; -------------------
  align 4
  pass112:
    cmp BYTE PTR [eax+3], "0"
    jne pass114
    ; -------------------
    mov eax, 224 ; 1110
    jmp nxt
    ; -------------------
  align 4
  pass114:
    ; -------------------
    mov eax, 240 ; 1111
    jmp nxt
    ; -------------------

; ******************************************
; ******************************************
; ******************************************

  align 4
  nxt:

    mov ecx, [esp+4]
    add ecx, 4

    cmp BYTE PTR [ecx+0], "0"
    jne lbl0
    cmp BYTE PTR [ecx+1], "0"
    jne lbl1
    cmp BYTE PTR [ecx+2], "0"
    jne lbl2
    cmp BYTE PTR [ecx+3], "0"
    jne lbl3
    ; -------------------
    ;;; add eax, 0
    ret 4
    ; -------------------
  align 4
  lbl3:
    ; -------------------
    add eax, 1
    ret 4
    ; -------------------
  align 4
  lbl2:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl4
    ; -------------------
    add eax, 2
    ret 4
    ; -------------------
  align 4
  lbl4:
    ; -------------------
    add eax, 3
    ret 4
    ; -------------------
  align 4
  lbl1:
    cmp BYTE PTR [ecx+2], "0"
    jne lbl5
    cmp BYTE PTR [ecx+3], "0"
    jne lbl6
    ; -------------------
    add eax, 4
    ret 4
    ; -------------------
  align 4
  lbl6:
    ; -------------------
    add eax, 5
    ret 4
    ; -------------------
  align 4
  lbl5:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl7
    ; -------------------
    add eax, 6
    ret 4
    ; -------------------
  align 4
  lbl7:
    ; -------------------
    add eax, 7
    ret 4
    ; -------------------
  align 4
  lbl0:
    cmp BYTE PTR [ecx+1], "0"
    jne lbl8
    cmp BYTE PTR [ecx+2], "0"
    jne lbl9
    cmp BYTE PTR [ecx+3], "0"
    jne lbl10
    ; -------------------
    add eax, 8
    ret 4
    ; -------------------
  align 4
  lbl10:
    ; -------------------
    add eax, 9
    ret 4
    ; -------------------
  align 4
  lbl9:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl11
    ; -------------------
    add eax, 10
    ret 4
    ; -------------------
  align 4
  lbl11:
    ; -------------------
    add eax, 11
    ret 4
    ; -------------------
  align 4
  lbl8:
    cmp BYTE PTR [ecx+2], "0"
    jne lbl12
    cmp BYTE PTR [ecx+3], "0"
    jne lbl13
    ; -------------------
    add eax, 12
    ret 4
    ; -------------------
  align 4
  lbl13:
    ; -------------------
    add eax, 13
    ret 4
    ; -------------------
  align 4
  lbl12:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl14
    ; -------------------
    add eax, 14
    ret 4
    ; -------------------
  align 4
  lbl14:
    ; -------------------
    add eax, 15
    ret 4
    ; -------------------

  notfound:
    mov eax, -1
    ret 4

bin2byte_exLib endp

; 
; 
; 

bin2byte_exLib_END:

ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start
OPT_WAIT	0
OPT_Tmp2Asm	1
